// USB2 API DLL exmaple program
// USB2DLL.h
// Copyright PassMark 2006
// www.passmark.com



#ifndef _USB2DLL_H_
#define _USB2DLL_H_

//
// Testing modes
#define LOOPBACK	1			// Change test to loopback mode
#define BENCHMARK	2			// Change test to benchmark mode

#define MAX_USB_DEV_NUMBER 32	// Number of USB device driver instances possible

#define USB_ERRORLOG_MSG_SIZE	128
#define USB_ERRORLOG_MAX		20

//Test pattern types
typedef enum _DATA_PATTERN 
{
    INCREMENTINGBYTE,
		RANDOMBYTE,
		INCREMENTINGDWORD,
		CONSTANTBYTE
} DATA_PATTERN;


extern "C" __declspec(dllexport) bool USB2GetUSBErrors(char errorLog[USB_ERRORLOG_MAX][USB_ERRORLOG_MSG_SIZE], int* numCopied, bool clearLog);
extern "C" __declspec(dllexport) int USB2GetBusErrors(int iDeviceNum);
extern "C" __declspec(dllexport) int USB2NumPlugsConnected();
extern "C" __declspec(dllexport) int USB2GetDeviceInfo (int PortNum, char *Serial, int MaxSerialLen, char *Desc, int MaxDescLen);

extern "C" __declspec(dllexport) bool USB2GetLoopbackResults(int iOperations[MAX_USB_DEV_NUMBER], int iErrors[MAX_USB_DEV_NUMBER]);

extern "C" __declspec(dllexport) bool USB2GetBenchmarkResults(int* iOperations, int* iErrors, float* maxRate, float* maxReadRate, 
															  float* maxWriteRate, float* avgRate, float* avgPossible);
extern "C" __declspec(dllexport) bool USB2StopTest();
extern "C" __declspec(dllexport) bool USB2StartTest();
extern "C" __declspec(dllexport) bool USB2GetConnectedPlugs(bool * bDeviceArray);
extern "C" __declspec(dllexport) bool USB2GetUSBEnumerationType(int iDeviceNum, bool * bHighSpeed, int * iFirmWare);
extern "C" __declspec(dllexport) bool USB2SetTestParameters(bool useplug[MAX_USB_DEV_NUMBER],  int mode, unsigned int duration, DATA_PATTERN dataPattern, unsigned long patternStart, bool verifyData);
extern "C" __declspec(dllexport) bool USB2TestIsRunning();
extern "C" __declspec(dllexport) bool USB2GetLastError(char* msg, int* msgSize);
#endif //_USB2DLL_H_